Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1429)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1430)
@@ -4062,5 +1827,5 @@
     if (rObj != Py_None)
     {
-        objr = (pjsip_rx_data_Object *)rObj;
+        objr = (PyObj_pjsip_rx_data *)rObj;
         rdata = objr->rdata;
     } else {
@@ -4107,5 +1872,10 @@
     "Modify account information.";
 static char pjsua_acc_set_online_status_doc[] =
-    "int py_pjsua.acc_set_online_status (int acc_id, int is_online) "
+    "int py_pjsua.acc_set_online_status2(int acc_id, int is_online) "
+    "Modify account's presence status to be advertised "
+    "to remote/presence subscribers.";
+static char pjsua_acc_set_online_status2_doc[] =
+    "int py_pjsua.acc_set_online_status (int acc_id, int is_online, "
+                                         "int activity_id, string activity_text) "
     "Modify account's presence status to be advertised "
     "to remote/presence subscribers.";
@@ -4127,15 +1897,15 @@
     "to used to reach to the specified URL.";
 static char pjsua_acc_find_for_incoming_doc[] =
-    "int py_pjsua.acc_find_for_incoming (pjsip_rx_data_Object rdata) "
+    "int py_pjsua.acc_find_for_incoming (PyObj_pjsip_rx_data rdata) "
     "This is an internal function to find the most appropriate account "
     "to be used to handle incoming calls.";
 static char pjsua_acc_create_uac_contact_doc[] =
-    "string py_pjsua.acc_create_uac_contact (pj_pool_Object pool, "
+    "string py_pjsua.acc_create_uac_contact (PyObj_pj_pool pool, "
     "int acc_id, string uri) "
     "Create a suitable URI to be put as Contact based on the specified "
     "target URI for the specified account.";
 static char pjsua_acc_create_uas_contact_doc[] =
-    "string py_pjsua.acc_create_uas_contact (pj_pool_Object pool, "
-    "int acc_id, pjsip_rx_data_Object rdata) "
+    "string py_pjsua.acc_create_uas_contact (PyObj_pj_pool pool, "
+    "int acc_id, PyObj_pjsip_rx_data rdata) "
     "Create a suitable URI to be put as Contact based on the information "
     "in the incoming request.";
@@ -4148,305 +1918,22 @@
 
 /*
- * buddy_config_Object
- * Buddy Config
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    
-    PyObject * uri;
-    int subscribe;
-} buddy_config_Object;
-
-
-/*
- * buddy_config_dealloc
- * deletes a buddy_config from memory
- */
-static void buddy_config_dealloc(buddy_config_Object* self)
-{
-    Py_XDECREF(self->uri);     
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * buddy_config_new
- * constructor for buddy_config object
- */
-static PyObject * buddy_config_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    buddy_config_Object *self;
-
-    self = (buddy_config_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->uri = PyString_FromString("");
-        if (self->uri == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }        
-    }
-    return (PyObject *)self;
-}
-
-/*
- * buddy_config_members
- */
-static PyMemberDef buddy_config_members[] =
-{
-    
-    {
-        "uri", T_OBJECT_EX,
-        offsetof(buddy_config_Object, uri), 0,
-        "TBuddy URL or name address."        
-    },
-    
-    {
-        "subscribe", T_INT, 
-        offsetof(buddy_config_Object, subscribe), 0,
-        "Specify whether presence subscription should start immediately. "
-    },
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * buddy_config_Type
- */
-static PyTypeObject buddy_config_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Buddy_Config",      /*tp_name*/
-    sizeof(buddy_config_Object),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)buddy_config_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Buddy Config objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    buddy_config_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    buddy_config_new,             /* tp_new */
-
-};
-
-/*
- * buddy_info_Object
- * Buddy Info
- * !modified @ 071206
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    int id;
-    PyObject * uri;
-    PyObject * contact;
-    int status;
-    PyObject * status_text;
-    int monitor_pres;
-    char buf_[256];
-} buddy_info_Object;
-
-
-/*
- * buddy_info_dealloc
- * deletes a buddy_info from memory
- * !modified @ 071206
- */
-static void buddy_info_dealloc(buddy_info_Object* self)
-{
-    Py_XDECREF(self->uri);
-    Py_XDECREF(self->contact);
-    Py_XDECREF(self->status_text);
-    
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * buddy_info_new
- * constructor for buddy_info object
- * !modified @ 071206
- */
-static PyObject * buddy_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    buddy_info_Object *self;
-
-    self = (buddy_info_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->uri = PyString_FromString("");
-        if (self->uri == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }        
-	self->contact = PyString_FromString("");
-        if (self->contact == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->status_text = PyString_FromString("");
-        if (self->status_text == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	
-    }
-    return (PyObject *)self;
-}
-
-/*
- * buddy_info_members
- * !modified @ 071206
- */
-static PyMemberDef buddy_info_members[] =
-{
-    {
-        "id", T_INT, 
-        offsetof(buddy_info_Object, id), 0,
-        "The buddy ID."
-    },
-    {
-        "uri", T_OBJECT_EX,
-        offsetof(buddy_info_Object, uri), 0,
-        "The full URI of the buddy, as specified in the configuration. "        
-    },
-    {
-        "contact", T_OBJECT_EX,
-        offsetof(buddy_info_Object, contact), 0,
-        "Buddy's Contact, only available when presence subscription "
-        "has been established to the buddy."        
-    },
-    {
-        "status", T_INT, 
-        offsetof(buddy_info_Object, status), 0,
-        "Buddy's online status. "
-    },
-    {
-        "status_text", T_OBJECT_EX,
-        offsetof(buddy_info_Object, status_text), 0,
-        "Text to describe buddy's online status."        
-    },
-    {
-        "monitor_pres", T_INT, 
-        offsetof(buddy_info_Object, monitor_pres), 0,
-        "Flag to indicate that we should monitor the presence information "
-        "for this buddy (normally yes, unless explicitly disabled). "
-    },
-    
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * buddy_info_Type
- */
-static PyTypeObject buddy_info_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Buddy_Info",      /*tp_name*/
-    sizeof(buddy_info_Object),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)buddy_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Buddy Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    buddy_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    buddy_info_new,             /* tp_new */
-
-};
-
-/*
  * py_pjsua_buddy_config_default
  */
-static PyObject *py_pjsua_buddy_config_default
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_buddy_config_default(PyObject *pSelf, 
+					       PyObject *pArgs)
 {    
-    buddy_config_Object *obj;	
+    PyObj_pjsua_buddy_config *obj;	
     pjsua_buddy_config cfg;
 
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
         return NULL;
     }
     
     pjsua_buddy_config_default(&cfg);
-    obj = (buddy_config_Object *) buddy_config_new
-		(&buddy_config_Type,NULL,NULL);
-    obj->uri = PyString_FromStringAndSize(
-        cfg.uri.ptr, cfg.uri.slen
-    );
-    obj->subscribe = cfg.subscribe;
+    obj = (PyObj_pjsua_buddy_config *) 
+	  PyObj_pjsua_buddy_config_new(&PyTyp_pjsua_buddy_config, NULL, NULL);
+    PyObj_pjsua_buddy_config_import(obj, &cfg);
     
     return (PyObject *)obj;
@@ -4456,11 +1943,11 @@
  * py_pjsua_get_buddy_count
  */
-static PyObject *py_pjsua_get_buddy_count
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_get_buddy_count(PyObject *pSelf, PyObject *pArgs)
 {    
     int ret;
 
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
         return NULL;
     }
@@ -4473,12 +1960,12 @@
  * py_pjsua_buddy_is_valid
  */
-static PyObject *py_pjsua_buddy_is_valid
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_buddy_is_valid(PyObject *pSelf, PyObject *pArgs)
 {    
     int id;
     int is_valid;
 
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }
@@ -4499,6 +1986,8 @@
     pjsua_buddy_id id[PJSUA_MAX_BUDDIES];
     unsigned c, i;
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
         return NULL;
     }	
@@ -4506,11 +1995,6 @@
     status = pjsua_enum_buddies(id, &c);
     list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {
-        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
-        if (ret == -1) 
-	{
-            return NULL;
-	}
+    for (i = 0; i < c; i++) {
+        PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
     }
     
@@ -4522,44 +2006,22 @@
  * !modified @ 071206
  */
-static PyObject *py_pjsua_buddy_get_info
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_buddy_get_info(PyObject *pSelf, PyObject *pArgs)
 {    	
     int buddy_id;
-    buddy_info_Object * obj;
+    PyObj_pjsua_buddy_info * obj;
     pjsua_buddy_info info;
     int status;	
-    int i;
-
-    if (!PyArg_ParseTuple(pArgs, "i", &buddy_id))
-    {
-        return NULL;
-    }
-	
-    
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &buddy_id)) {
+        return NULL;
+    }
+
     status = pjsua_buddy_get_info(buddy_id, &info);
-    if (status == PJ_SUCCESS) 
-    {
-	obj = (buddy_info_Object *)buddy_info_new(&buddy_info_Type,NULL,NULL);
-        obj->id = info.id;
-        Py_XDECREF(obj->uri);
-        obj->uri =
-            PyString_FromStringAndSize(info.uri.ptr, 
-            info.uri.slen);
-        Py_XDECREF(obj->contact);
-        obj->contact =
-            PyString_FromStringAndSize(info.contact.ptr, 
-            info.contact.slen);
-        obj->status = info.status;
-        Py_XDECREF(obj->status_text);
-        obj->status_text =
-            PyString_FromStringAndSize(info.status_text.ptr, 
-            info.status_text.slen);
-        obj->monitor_pres = info.monitor_pres;
-        for (i = 0; i < 256; i++) 
-	{
-	    
-            obj->buf_[i] = info.buf_[i];
-	}
-	
+    if (status == PJ_SUCCESS) {
+	obj = (PyObj_pjsua_buddy_info *)
+	      PyObj_pjsua_buddy_config_new(&PyTyp_pjsua_buddy_info,NULL,NULL);
+	PyObj_pjsua_buddy_info_import(obj, &info);	
         return Py_BuildValue("O", obj);
     } else {
@@ -4573,32 +2035,31 @@
  * !modified @ 061206
  */
-static PyObject *py_pjsua_buddy_add
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_buddy_add(PyObject *pSelf, PyObject *pArgs)
 {   
     PyObject * bcObj;
-    buddy_config_Object * bc;
-	
-    pjsua_buddy_config cfg;
-    
-    int p_buddy_id;
+    int buddy_id;
     int status;
 
-    if (!PyArg_ParseTuple(pArgs, "O", &bcObj))
-    {
-        return NULL;
-    }
-    if (bcObj != Py_None)
-    {
-        bc = (buddy_config_Object *)bcObj;
-
-        cfg.subscribe = bc->subscribe;
-        cfg.uri.ptr = PyString_AsString(bc->uri);
-        cfg.uri.slen = strlen(PyString_AsString(bc->uri));    
-    
-        status = pjsua_buddy_add(&cfg, &p_buddy_id);
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "O", &bcObj)) {
+        return NULL;
+    }
+
+    if (bcObj != Py_None) {
+	pjsua_buddy_config cfg;
+	PyObj_pjsua_buddy_config * bc;
+
+        bc = (PyObj_pjsua_buddy_config *)bcObj;
+
+	pjsua_buddy_config_default(&cfg);
+        PyObj_pjsua_buddy_config_export(&cfg, bc);  
+    
+        status = pjsua_buddy_add(&cfg, &buddy_id);
     } else {
-        status = pjsua_buddy_add(NULL, &p_buddy_id);
-    }
-    return Py_BuildValue("ii", status, p_buddy_id);
+        status = PJ_EINVAL;
+	buddy_id = PJSUA_INVALID_ID;
+    }
+    return Py_BuildValue("ii", status, buddy_id);
 }
 
@@ -4606,12 +2067,12 @@
  * py_pjsua_buddy_del
  */
-static PyObject *py_pjsua_buddy_del
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_buddy_del(PyObject *pSelf, PyObject *pArgs)
 {    
     int buddy_id;
     int status;
 
-    if (!PyArg_ParseTuple(pArgs, "i", &buddy_id))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &buddy_id)) {
         return NULL;
     }
@@ -4625,6 +2086,5 @@
  * py_pjsua_buddy_subscribe_pres
  */
-static PyObject *py_pjsua_buddy_subscribe_pres
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_buddy_subscribe_pres(PyObject *pSelf, PyObject *pArgs)
 {    
     int buddy_id;
@@ -4632,6 +2092,7 @@
     int subscribe;
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &buddy_id, &subscribe))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "ii", &buddy_id, &subscribe)) {
         return NULL;
     }
@@ -4645,11 +2106,11 @@
  * py_pjsua_pres_dump
  */
-static PyObject *py_pjsua_pres_dump
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_pres_dump(PyObject *pSelf, PyObject *pArgs)
 {    
     int verbose;
 
-    if (!PyArg_ParseTuple(pArgs, "i", &verbose))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &verbose)) {
         return NULL;
     }
@@ -4665,6 +2126,5 @@
  * !modified @ 071206
  */
-static PyObject *py_pjsua_im_send
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_im_send(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
@@ -4677,10 +2137,11 @@
     pjsua_msg_data msg_data;
     PyObject * omdObj;
-    msg_data_Object * omd;
+    PyObj_pjsua_msg_data * omd;
     
     int user_data;
     pj_pool_t *pool;
 
-   
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "iOOOOi", &acc_id, 
 		&st, &smt, &sc, &omdObj, &user_data))
@@ -4688,26 +2149,18 @@
         return NULL;
     }
-    if (smt != Py_None)
-    {
+    if (smt != Py_None) {
         mime_type = &tmp_mime_type;
-        tmp_mime_type.ptr = PyString_AsString(smt);
-        tmp_mime_type.slen = strlen(PyString_AsString(smt));
+	tmp_mime_type = PyString_to_pj_str(smt);
     } else {
         mime_type = NULL;
     }
-    to.ptr = PyString_AsString(st);
-    to.slen = strlen(PyString_AsString(st));
-    
-    content.ptr = PyString_AsString(sc);
-    content.slen = strlen(PyString_AsString(sc));
-    if (omdObj != Py_None)
-    {
+    to = PyString_to_pj_str(st);
+        content = PyString_to_pj_str(sc);
+
+    if (omdObj != Py_None) {
 		
-        omd = (msg_data_Object *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
+        omd = (PyObj_pjsua_msg_data *)omdObj;
+	msg_data.content_type = PyString_to_pj_str(omd->content_type);
+	msg_data.msg_body = PyString_to_pj_str(omd->msg_body);
         pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
 
@@ -4728,6 +2181,5 @@
  * py_pjsua_im_typing
  */
-static PyObject *py_pjsua_im_typing
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_im_typing(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
@@ -4738,22 +2190,19 @@
     pjsua_msg_data msg_data;
     PyObject * omdObj;
-    msg_data_Object * omd;
+    PyObj_pjsua_msg_data * omd;
     pj_pool_t * pool;
 
-    if (!PyArg_ParseTuple(pArgs, "iOiO", &acc_id, &st, &is_typing, &omdObj))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iOiO", &acc_id, &st, &is_typing, &omdObj)) {
         return NULL;
     }
 	
-    to.ptr = PyString_AsString(st);
-    to.slen = strlen(PyString_AsString(st));    
-    if (omdObj != Py_None)
-    {
-        omd = (msg_data_Object *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
+    to = PyString_to_pj_str(st);
+
+    if (omdObj != Py_None) {
+        omd = (PyObj_pjsua_msg_data *)omdObj;
+	msg_data.content_type = PyString_to_pj_str(omd->content_type);
+	msg_data.msg_body = PyString_to_pj_str(omd->msg_body);
         pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
 
@@ -4811,5 +2260,5 @@
 
 /*
- * codec_info_Object
+ * PyObj_pjsua_codec_info
  * Codec Info
  * !modified @ 071206
@@ -4823,5 +2272,5 @@
     pj_uint8_t priority;    
     char buf_[32];
-} codec_info_Object;
+} PyObj_pjsua_codec_info;
 
 
@@ -4831,5 +2280,5 @@
  * !modified @ 071206
  */
-static void codec_info_dealloc(codec_info_Object* self)
+static void codec_info_dealloc(PyObj_pjsua_codec_info* self)
 {
     Py_XDECREF(self->codec_id);    
@@ -4847,7 +2296,10 @@
                                     PyObject *kwds)
 {
-    codec_info_Object *self;
-
-    self = (codec_info_Object *)type->tp_alloc(type, 0);
+    PyObj_pjsua_codec_info *self;
+
+    PJ_UNUSED_ARG(args);
+    PJ_UNUSED_ARG(kwds);
+
+    self = (PyObj_pjsua_codec_info *)type->tp_alloc(type, 0);
     if (self != NULL)
     {
@@ -4872,5 +2324,5 @@
     {
         "codec_id", T_OBJECT_EX,
-        offsetof(codec_info_Object, codec_id), 0,
+        offsetof(PyObj_pjsua_codec_info, codec_id), 0,
         "Codec unique identification."        
     },
@@ -4878,5 +2330,5 @@
     {
         "priority", T_INT, 
-        offsetof(codec_info_Object, priority), 0,
+        offsetof(PyObj_pjsua_codec_info, priority), 0,
         "Codec priority (integer 0-255)."
     },
@@ -4891,12 +2343,12 @@
 
 /*
- * codec_info_Type
- */
-static PyTypeObject codec_info_Type =
+ * PyTyp_pjsua_codec_info
+ */
+static PyTypeObject PyTyp_pjsua_codec_info =
 {
     PyObject_HEAD_INIT(NULL)
     0,                              /*ob_size*/
     "py_pjsua.Codec_Info",      /*tp_name*/
-    sizeof(codec_info_Object),  /*tp_basicsize*/
+    sizeof(PyObj_pjsua_codec_info),  /*tp_basicsize*/
     0,                              /*tp_itemsize*/
     (destructor)codec_info_dealloc,/*tp_dealloc*/
@@ -4938,5 +2390,5 @@
 
 /*
- * conf_port_info_Object
+ * PyObj_pjsua_conf_port_info
  * Conf Port Info
  */
@@ -4955,5 +2407,5 @@
     PyListObject * listeners;
 
-} conf_port_info_Object;
+} PyObj_pjsua_conf_port_info;
 
 
@@ -4962,5 +2414,5 @@
  * deletes a conf_port_info from memory
  */
-static void conf_port_info_dealloc(conf_port_info_Object* self)
+static void conf_port_info_dealloc(PyObj_pjsua_conf_port_info* self)
 {
     Py_XDECREF(self->name);    
@@ -4977,7 +2429,10 @@
                                     PyObject *kwds)
 {
-    conf_port_info_Object *self;
-
-    self = (conf_port_info_Object *)type->tp_alloc(type, 0);
+    PyObj_pjsua_conf_port_info *self;
+
+    PJ_UNUSED_ARG(args);
+    PJ_UNUSED_ARG(kwds);
+
+    self = (PyObj_pjsua_conf_port_info *)type->tp_alloc(type, 0);
     if (self != NULL)
     {
@@ -5006,40 +2461,40 @@
     {
         "slot_id", T_INT, 
-        offsetof(conf_port_info_Object, slot_id), 0,
+        offsetof(PyObj_pjsua_conf_port_info, slot_id), 0,
         "Conference port number."
     },
     {
         "name", T_OBJECT_EX,
-        offsetof(conf_port_info_Object, name), 0,
+        offsetof(PyObj_pjsua_conf_port_info, name), 0,
         "Port name"        
     },
     {
         "clock_rate", T_INT, 
-        offsetof(conf_port_info_Object, clock_rate), 0,
+        offsetof(PyObj_pjsua_conf_port_info, clock_rate), 0,
         "Clock rate"
     },
     {
         "channel_count", T_INT, 
-        offsetof(conf_port_info_Object, channel_count), 0,
+        offsetof(PyObj_pjsua_conf_port_info, channel_count), 0,
         "Number of channels."
     },
     {
         "samples_per_frame", T_INT, 
-        offsetof(conf_port_info_Object, samples_per_frame), 0,
+        offsetof(PyObj_pjsua_conf_port_info, samples_per_frame), 0,
         "Samples per frame "
     },
     {
         "bits_per_sample", T_INT, 
-        offsetof(conf_port_info_Object, bits_per_sample), 0,
+        offsetof(PyObj_pjsua_conf_port_info, bits_per_sample), 0,
         "Bits per sample"
     },
     {
         "listener_cnt", T_INT, 
-        offsetof(conf_port_info_Object, listener_cnt), 0,
+        offsetof(PyObj_pjsua_conf_port_info, listener_cnt), 0,
         "Number of listeners in the array."
     },
     {
         "listeners", T_OBJECT_EX,
-        offsetof(conf_port_info_Object, listeners), 0,
+        offsetof(PyObj_pjsua_conf_port_info, listeners), 0,
         "Array of listeners (in other words, ports where this port "
 	"is transmitting to"
@@ -5053,12 +2508,12 @@
 
 /*
- * conf_port_info_Type
- */
-static PyTypeObject conf_port_info_Type =
+ * PyTyp_pjsua_conf_port_info
+ */
+static PyTypeObject PyTyp_pjsua_conf_port_info =
 {
     PyObject_HEAD_INIT(NULL)
     0,                              /*ob_size*/
     "py_pjsua.Conf_Port_Info",      /*tp_name*/
-    sizeof(conf_port_info_Object),  /*tp_basicsize*/
+    sizeof(PyObj_pjsua_conf_port_info),  /*tp_basicsize*/
     0,                              /*tp_itemsize*/
     (destructor)conf_port_info_dealloc,/*tp_dealloc*/
@@ -5100,5 +2555,5 @@
 
 /*
- * pjmedia_port_Object
+ * PyObj_pjmedia_port
  */
 typedef struct
@@ -5107,16 +2562,16 @@
     /* Type-specific fields go here. */
     pjmedia_port * port;
-} pjmedia_port_Object;
-
-
-/*
- * pjmedia_port_Type
- */
-static PyTypeObject pjmedia_port_Type =
+} PyObj_pjmedia_port;
+
+
+/*
+ * PyTyp_pjmedia_port
+ */
+static PyTypeObject PyTyp_pjmedia_port =
 {
     PyObject_HEAD_INIT(NULL)
     0,                         /*ob_size*/
     "py_pjsua.PJMedia_Port",        /*tp_name*/
-    sizeof(pjmedia_port_Object),    /*tp_basicsize*/
+    sizeof(PyObj_pjmedia_port),    /*tp_basicsize*/
     0,                         /*tp_itemsize*/
     0,                         /*tp_dealloc*/
@@ -5141,5 +2596,5 @@
 
 /*
- * pjmedia_snd_dev_info_Object
+ * PyObj_pjmedia_snd_dev_info
  * PJMedia Snd Dev Info
  */
@@ -5155,5 +2610,5 @@
     PyObject * name;
 
-} pjmedia_snd_dev_info_Object;
+} PyObj_pjmedia_snd_dev_info;
 
 
@@ -5162,5 +2617,5 @@
  * deletes a pjmedia_snd_dev_info from memory
  */
-static void pjmedia_snd_dev_info_dealloc(pjmedia_snd_dev_info_Object* self)
+static void pjmedia_snd_dev_info_dealloc(PyObj_pjmedia_snd_dev_info* self)
 {
     Py_XDECREF(self->name);        
@@ -5176,7 +2631,10 @@
                                     PyObject *kwds)
 {
-    pjmedia_snd_dev_info_Object *self;
-
-    self = (pjmedia_snd_dev_info_Object *)type->tp_alloc(type, 0);
+    PyObj_pjmedia_snd_dev_info *self;
+
+    PJ_UNUSED_ARG(args);
+    PJ_UNUSED_ARG(kwds);
+
+    self = (PyObj_pjmedia_snd_dev_info *)type->tp_alloc(type, 0);
     if (self != NULL)
     {
@@ -5200,20 +2658,20 @@
     {
         "name", T_OBJECT_EX,
-        offsetof(pjmedia_snd_dev_info_Object, name), 0,
+        offsetof(PyObj_pjmedia_snd_dev_info, name), 0,
         "Device name"        
     },
     {
         "input_count", T_INT, 
-        offsetof(pjmedia_snd_dev_info_Object, input_count), 0,
+        offsetof(PyObj_pjmedia_snd_dev_info, input_count), 0,
         "Max number of input channels"
     },
     {
         "output_count", T_INT, 
-        offsetof(pjmedia_snd_dev_info_Object, output_count), 0,
+        offsetof(PyObj_pjmedia_snd_dev_info, output_count), 0,
         "Max number of output channels"
     },
     {
         "default_samples_per_sec", T_INT, 
-        offsetof(pjmedia_snd_dev_info_Object, default_samples_per_sec), 0,
+        offsetof(PyObj_pjmedia_snd_dev_info, default_samples_per_sec), 0,
         "Default sampling rate."
     },
@@ -5227,12 +2685,12 @@
 
 /*
- * pjmedia_snd_dev_info_Type
- */
-static PyTypeObject pjmedia_snd_dev_info_Type =
+ * PyTyp_pjmedia_snd_dev_info
+ */
+static PyTypeObject PyTyp_pjmedia_snd_dev_info =
 {
     PyObject_HEAD_INIT(NULL)
     0,                              /*ob_size*/
     "py_pjsua.PJMedia_Snd_Dev_Info",      /*tp_name*/
-    sizeof(pjmedia_snd_dev_info_Object),  /*tp_basicsize*/
+    sizeof(PyObj_pjmedia_snd_dev_info),  /*tp_basicsize*/
     0,                              /*tp_itemsize*/
     (destructor)pjmedia_snd_dev_info_dealloc,/*tp_dealloc*/
@@ -5274,5 +2732,5 @@
 
 /*
- * pjmedia_codec_param_info_Object
+ * PyObj_pjmedia_codec_param_info
  * PJMedia Codec Param Info
  */
@@ -5289,5 +2747,5 @@
     pj_uint8_t  pt;	
 
-} pjmedia_codec_param_info_Object;
+} PyObj_pjmedia_codec_param_info;
 
 
@@ -5301,30 +2759,30 @@
     {
         "clock_rate", T_INT, 
-        offsetof(pjmedia_codec_param_info_Object, clock_rate), 0,
+        offsetof(PyObj_pjmedia_codec_param_info, clock_rate), 0,
         "Sampling rate in Hz"
     },
     {
         "channel_cnt", T_INT, 
-        offsetof(pjmedia_codec_param_info_Object, channel_cnt), 0,
+        offsetof(PyObj_pjmedia_codec_param_info, channel_cnt), 0,
         "Channel count"
     },
     {
         "avg_bps", T_INT, 
-        offsetof(pjmedia_codec_param_info_Object, avg_bps), 0,
+        offsetof(PyObj_pjmedia_codec_param_info, avg_bps), 0,
         "Average bandwidth in bits/sec"
     },
     {
         "frm_ptime", T_INT, 
-        offsetof(pjmedia_codec_param_info_Object, frm_ptime), 0,
+        offsetof(PyObj_pjmedia_codec_param_info, frm_ptime), 0,
         "Base frame ptime in msec."
     },
     {
         "pcm_bits_per_sample", T_INT, 
-        offsetof(pjmedia_codec_param_info_Object, pcm_bits_per_sample), 0,
+        offsetof(PyObj_pjmedia_codec_param_info, pcm_bits_per_sample), 0,
         "Bits/sample in the PCM side"
     },
     {
         "pt", T_INT, 
-        offsetof(pjmedia_codec_param_info_Object, pt), 0,
+        offsetof(PyObj_pjmedia_codec_param_info, pt), 0,
         "Payload type"
     },
@@ -5337,12 +2795,12 @@
 
 /*
- * pjmedia_codec_param_info_Type
- */
-static PyTypeObject pjmedia_codec_param_info_Type =
+ * PyTyp_pjmedia_codec_param_info
+ */
+static PyTypeObject PyTyp_pjmedia_codec_param_info =
 {
     PyObject_HEAD_INIT(NULL)
     0,                              /*ob_size*/
     "py_pjsua.PJMedia_Codec_Param_Info",      /*tp_name*/
-    sizeof(pjmedia_codec_param_info_Object),  /*tp_basicsize*/
+    sizeof(PyObj_pjmedia_codec_param_info),  /*tp_basicsize*/
     0,                              /*tp_itemsize*/
     0,/*tp_dealloc*/
@@ -5376,5 +2834,5 @@
 
 /*
- * pjmedia_codec_param_setting_Object
+ * PyObj_pjmedia_codec_param_setting
  * PJMedia Codec Param Setting
  */
@@ -5392,5 +2850,5 @@
     pj_uint8_t  dec_fmtp_mode; 
 
-} pjmedia_codec_param_setting_Object;
+} PyObj_pjmedia_codec_param_setting;
 
 
